var currentPage = 1;
var total = 1;
var refreshTaskId;

var widthper;
var heightper;
var percentage;
var moveToTop = 0;
var moveToLeft = 0;

var isTablet = false;
var canScroll = false;

function isMobile(){
	var ua = navigator.userAgent.toLowerCase();
	if(ua.indexOf("android") > -1 || //Android System
		ua.indexOf("iphone") > -1 || //IPhone
		ua.indexOf("Noki") > -1 || // Nokia phones and emulators
		ua.indexOf("Eric") > -1 || // Ericsson WAP phones and emulators
		ua.indexOf("WapI") > -1 || // Ericsson WapIDE 2.0
		ua.indexOf("MC21") > -1 || // Ericsson MC218
		ua.indexOf("AUR") > -1  || // Ericsson R320
		ua.indexOf("R380") > -1 || // Ericsson R380
		ua.indexOf("UP.B") > -1 || // UP.Browser
		ua.indexOf("WinW") > -1 || // WinWAP browser
		ua.indexOf("UPG1") > -1 || // UP.SDK 4.0
		ua.indexOf("upsi") > -1 || //another kind of UP.Browser
		ua.indexOf("QWAP") > -1 || // unknown QWAPPER browser
		ua.indexOf("Jigs") > -1 || // unknown JigSaw browser
		ua.indexOf("Java") > -1 || // unknown Java based browser
		ua.indexOf("Alca") > -1 || // unknown Alcatel-BE3 browser (UP based)
		ua.indexOf("MITS") > -1 || // unknown Mitsubishi browser
		ua.indexOf("MOT-") > -1 || // unknown browser (UP based)
		ua.indexOf("My S") > -1 || //  unknown Ericsson devkit browser 
		ua.indexOf("WAPJ") > -1 || //Virtual WAPJAG www.wapjag.de
		ua.indexOf("fetc") > -1 || //fetchpage.cgi Perl script from www.wapcab.de
		ua.indexOf("ALAV") > -1 || //yet another unknown UP based browser
		ua.indexOf("Wapa") > -1 || //another unknown browser (Web based "Wapalyzer")
		ua.indexOf("Oper") > -1){
		return true;
	}
	else
		return false;
}
function transform(){
	var tr = $("#page");
//	tr.css("-webkit-transform","scale("+widthper+","+heightper+")");
//	tr.css("-webkit-transform","scale("+percentage+","+percentage+")");
	tr.css("-webkit-transform","scale("+percentage+")");
}
function moveTo(){
	var page = $("#page");
	if (isTablet) {
		page.css("position", "relative");
		page.css("top", moveToTop);
		page.css("bottom", moveToTop);
		page.css("left", 0);
		page.css("right", 0);
		page.css("margin-left", "auto");
		page.css("margin-right", "auto");
	} else {
		page.css("position", "relative");
		page.css("top", moveToTop);
		page.css("left", moveToLeft);
	}
}
function getPercentage(){
	var width = document.body.scrollWidth;
	var height = document.body.scrollHeight;
	
    window.android.printJsWidth(width,cWidth);
    window.android.printJsHeight(height,cHeight);
    
	widthper = cWidth/width; 
	heightper = cHeight/height;
	
	if(width*heightper > cWidth){
		percentage = widthper;	
		moveToLeft = -(1-percentage)*width/2;
		moveToTop = -(1-percentage)*height/2+(cHeight-height*percentage)/2;	
	}
	else{
		percentage = heightper;
		moveToLeft = -(1-percentage)*width/2+(cWidth-width*percentage)/2;
		moveToTop = -(1-percentage)*height/2;
	}	
}
function displayPage() {
	getPercentage();
	transform();
	moveTo();
}
function lengthHelper(len) {
	/*
	 * var $div = $("<div></div>"); $div.appendTo($("body"));
	 * $div.css("width", len); var width = $div.width();
	 */
	// return width+1;//for firefox should be width,chrome and sarfri should be
	// 2 pix more
	return 37.795275591;
}

function refreshStatus() {
	$.ajax({
		url : "status",
		dataType : 'json',
		success : function(data) {
			window.total = Number(data.total);
			window.android.setTotal(window.total);			
			if(data.finished){
				clearInterval(refreshTaskId);
				window.android.setSeekBarEnabled();						
			}
		}
	});
}
function wait(show) {
	if (show) {
		var $wait = $("#wait");
		$wait.show();
		var txt = $wait.text();
		if (txt == "Loading.") {
			$wait.text("Loading..");
		} else if (txt == "Loading..") {
			$wait.text("Loading...");
		} else {
			$wait.text("Loading.");
		}
	} else {
		$("#wait").hide();
	}
}

$(function() {
	
	$("#pageSelection").hide();
	wait(true);
	refreshTaskId = setInterval("refreshStatus()", 1000);
	deta = lengthHelper("1cm");
	
	try{			
		page();
	} catch(e) {
	}
	
	//$(".editable, .singleline_editable").click(edit);
	//$("#button").css("wdith", $("#page").css("width"));
	
});
window.onscroll=function() { 
	if(!canScroll)
		window.scrollTo(0,0)
}
window.onload = function(){
	window.android.printDeviceType(deviceType);
	isTablet = deviceType.indexOf("tablet") > -1;
	displayPage();
}
function scrollYes(){
	canScroll = true;
}
function scrollNo(){
	canScroll = false;
}
function edit() {
	//alert('edit');
	nativeObj.beginEdit();
	var content = $(this);	
	content.unbind('click');
	var text = getText(content);
	var editor;
	if( content.is(".singleline_editable")) {
		editor = $("<input type=\"text\"/>");
	} else {
		editor = $("<textarea></textarea>");
	}	
	//alert(text);
	
	editor.css("width", content.width());
	editor.css("height", content.height());
	editor.val(text);
	
	content.empty();
	content.append(editor);
	editor.focus();
	
	/*
	var exit = $("<span>x</span>");
	exit.css("position","absolute");
	var pos = editor.position();
	exit.css("left", editor.width()+pos.left);
	exit.css("top", pos.top);
	exit.insertAfter(editor);
	*/
	
	var writeBack = function(eventObject){
		
		var id = content.attr("id");
		var val = editor.val();
		var newContent = content.clone();
		newContent.empty();
		
		newContent.append($("<span>"+val.replace(/\n/g, "<br/>")+"</span>"));
		content.replaceWith(newContent);
		nativeObj.update(id, val);
		newContent.click(edit);		
		nativeObj.endEdit();
	}
	
	//exit.click( writeBack );
	editor.focusout( writeBack);
	//alert( content.html());
}

function getText(jqNode) {
	var nodeHtml = jqNode.html();
	nodeHtml = nodeHtml.replace(/<br\s*\/?>/g, "\n");
	nodeHtml = nodeHtml.replace(/<[^>]+>/g, "");
	return nodeHtml;
}

function drawEllipse(ctx, x, y, w, h) {
	var kappa = .5522848;
	ox = (w / 2) * kappa, // control point offset horizontal
	oy = (h / 2) * kappa, // control point offset vertical
	xe = x + w, // x-end
	ye = y + h, // y-end
	xm = x + w / 2, // x-middle
	ym = y + h / 2; // y-middle

	ctx.beginPath();
	ctx.moveTo(x, ym);
	ctx.bezierCurveTo(x, ym - oy, xm - ox, y, xm, y);
	ctx.bezierCurveTo(xm + ox, y, xe, ym - oy, xe, ym);
	ctx.bezierCurveTo(xe, ym + oy, xm + ox, ye, xm, ye);
	ctx.bezierCurveTo(xm - ox, ye, x, ym + oy, x, ym);
	ctx.closePath();
	ctx.stroke();
	ctx.fill();
}

function drawGeneralShape(ctx, x, y, w, h, path) {

	var strs = new Array(); // array
	w = h;
	strs = path.split(" "); // split
	if (strs[0] == "V") {
		ctx.beginPath();
		var x1 = eval(strs[1] * w / 21600);
		var y1 = eval(strs[2] * h / 21600);
		var x2 = eval(strs[3] * w / 21600);
		var y2 = eval(strs[4] * h / 21600);
		var x3 = eval(strs[5] * w / 21600);
		var y3 = eval(strs[6] * h / 21600);
		var x4 = eval(strs[7] * w / 21600);
		var y4 = eval(strs[8] * h / 21600);
		var x = eval((x1 + x2) / 2); // x coordinate
		var y = eval((y1 + y2) / 2); // y coordinate
		var radius = eval((x2 - x1) / 2); // Arc radius
		var startAngle = eval(Math.atan((y3 - y) / (x3 - x))); // Starting
																// point on
																// circle
		var endAngle = eval(Math.atan((y4 - y) / (x4 - x))); // End point on
																// circle
		var anticlockwise = false; // clockwise or anticlockwise

		ctx.arc(x, y, radius, startAngle, endAngle, anticlockwise);

		ctx.lineTo(x, y);
		ctx.lineTo(x3, y3);
		if (strs[13] == "N") {
			ctx.fill();
		}
	}

}
// Table 11 - Functions Used in draw:formula
function SVGif(var_c, var_x, var_y) {
	return var_c > 0 ? var_x : var_y;
}


