dojo.provide("websheet.parse.referenceToken");
dojo.declare("websheet.parse.referenceToken", null, {

	_text: null,          // original value
	_changedText:null,    // changed value
	_index: null,
	_type:null,
	
	constructor: function(args) {
		dojo.mixin(this, args);
	},
	
	/**
	 *
	 * @param {String} paramCols
	 */
	setText:function(text)
	{
	    this._text = text;
	},
	
	getText:function()
	{
	   return this._text;
	},
	
	setChangedText:function(text)
	{
	    this._changedText = text;
	},
	
	getChangedText:function()
	{
	   return this._changedText;
	},
	
	setIndex:function(index)
	{
	    this._index = index;
	},
	
	getIndex:function()
	{
	   return this._index;
	},
	
	setType:function(type)
	{
	    this._type = type;
	},
	
	getType:function()
	{
	   return this._type;
	}
});
